const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const deliverables = sequelize.define(
    'deliverables',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

message: {
        type: DataTypes.TEXT,
      
      

      },

submitted_at: {
        type: DataTypes.DATE,
      
      

      },

review_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"changes_requested",


"approved"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  deliverables.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.deliverables.belongsTo(db.contracts, {
      as: 'contract',
      foreignKey: {
        name: 'contractId',
      },
      constraints: false,
    });

    db.deliverables.belongsTo(db.milestones, {
      as: 'milestone',
      foreignKey: {
        name: 'milestoneId',
      },
      constraints: false,
    });

    db.deliverables.belongsTo(db.users, {
      as: 'submitted_by',
      foreignKey: {
        name: 'submitted_byId',
      },
      constraints: false,
    });



    db.deliverables.hasMany(db.file, {
      as: 'files',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.deliverables.getTableName(),
        belongsToColumn: 'files',
      },
    });

    db.deliverables.hasMany(db.file, {
      as: 'images',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.deliverables.getTableName(),
        belongsToColumn: 'images',
      },
    });


    db.deliverables.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.deliverables.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return deliverables;
};


